--- old/usr/src/uts/common/sys/zone.h	2016-06-02 19:52:10.380902482 -0400
+++ new/usr/src/uts/common/sys/zone.h	2016-06-02 19:52:10.408350587 -0400
@@ -40,6 +40,7 @@
 #include <sys/uadmin.h>
 #include <sys/ksynch.h>
 #include <sys/socket_impl.h>
+#include <sys/secflags.h>
 #include <netinet/in.h>
 
 #ifdef	__cplusplus
@@ -104,6 +105,7 @@
 #define	ZONE_ATTR_FS_ALLOWED	16
 #define	ZONE_ATTR_NETWORK	17
 #define	ZONE_ATTR_INITNORESTART	20
+#define	ZONE_ATTR_SECFLAGS	21
 
 /* Start of the brand-specific attribute namespace */
 #define	ZONE_ATTR_BRAND_ATTRS	32768
@@ -578,6 +580,8 @@
 	uint64_t	zone_fspgin;		/* fs pages paged in */
 	uint64_t	zone_anon_alloc_fail;	/* cnt of anon alloc fails */
 
+	psecflags_t	zone_secflags; /* default zone security-flags */
+
 	/*
 	 * Misc. kstats and counters for zone cpu-usage aggregation.
 	 * The zone_Xtime values are the sum of the micro-state accounting
--- old/usr/src/uts/common/syscall/ppriv.c	2016-06-02 19:52:11.301878735 -0400
+++ new/usr/src/uts/common/syscall/ppriv.c	2016-06-02 19:52:11.329116756 -0400
@@ -187,7 +187,7 @@
 	 * empty. That is not portable.
 	 */
 	if ((type == PRIV_EFFECTIVE || type == PRIV_PERMITTED) &&
-	    priv_basic_test >= 0 && !PRIV_ISASSERT(target, priv_basic_test)) {
+	    priv_basic_test >= 0 && !PRIV_ISMEMBER(target, priv_basic_test)) {
 		proc_t *p = curproc;
 		pid_t pid = p->p_pid;
 		char *fn = PTOU(p)->u_comm;
--- /dev/null	2016-06-02 19:52:12.000000000 -0400
+++ new/usr/src/uts/common/syscall/psecflags.c	2016-06-02 19:52:12.166618421 -0400
@@ -0,0 +1,121 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/* Copyright 2015, Richard Lowe. */
+
+#include <sys/ddi.h>
+#include <sys/errno.h>
+#include <sys/policy.h>
+#include <sys/proc.h>
+#include <sys/procset.h>
+#include <sys/systm.h>
+#include <sys/types.h>
+#include <c2/audit.h>
+
+struct psdargs {
+	psecflagwhich_t which;
+	const secflagdelta_t *delta;
+};
+
+void
+secflags_apply_delta(secflagset_t *set, const secflagdelta_t *delta)
+{
+	if (delta->psd_ass_active) {
+		secflags_copy(set, &delta->psd_assign);
+	} else {
+		if (!secflags_isempty(delta->psd_add)) {
+			secflags_union(set, &delta->psd_add);
+		}
+		if (!secflags_isempty(delta->psd_rem)) {
+			secflags_difference(set, &delta->psd_rem);
+		}
+	}
+}
+
+
+static int
+psecdo(proc_t *p, struct psdargs *args)
+{
+	secflagset_t *set;
+	int ret = 0;
+
+	mutex_enter(&p->p_lock);
+
+	if (secpolicy_psecflags(CRED(), p, curproc) != 0) {
+		ret = EPERM;
+		goto out;
+	}
+
+	ASSERT(args->which != PSF_EFFECTIVE);
+
+	if (!psecflags_validate_delta(&p->p_secflags, args->delta)) {
+		ret = EINVAL;
+		goto out;
+	}
+
+	if (AU_AUDITING())
+		audit_psecflags(p, args->which, args->delta);
+
+	switch (args->which) {
+	case PSF_INHERIT:
+		set = &p->p_secflags.psf_inherit;
+		break;
+	case PSF_LOWER:
+		set = &p->p_secflags.psf_lower;
+		break;
+	case PSF_UPPER:
+		set = &p->p_secflags.psf_upper;
+		break;
+	}
+
+	secflags_apply_delta(set, args->delta);
+
+	/*
+	 * Add any flag now in the lower that is not in the inheritable.
+	 */
+	secflags_union(&p->p_secflags.psf_inherit, &p->p_secflags.psf_lower);
+
+out:
+	mutex_exit(&p->p_lock);
+	return (ret);
+}
+
+int
+psecflags(procset_t *psp, psecflagwhich_t which, secflagdelta_t *ap)
+{
+	procset_t procset;
+	secflagdelta_t args;
+	int rv = 0;
+	struct psdargs psd = {
+		.which = which,
+	};
+
+	/* Can never change the effective flags */
+	if (psd.which == PSF_EFFECTIVE)
+		return (EINVAL);
+
+	if (copyin(psp, &procset, sizeof (procset)) != 0)
+		return (set_errno(EFAULT));
+
+	if (copyin(ap, &args, sizeof (secflagdelta_t)) != 0)
+		return (set_errno(EFAULT));
+
+	psd.delta = &args;
+
+	/* secflags are per-process, procset must be in terms of processes */
+	if ((procset.p_lidtype == P_LWPID) ||
+	    (procset.p_ridtype == P_LWPID))
+		return (set_errno(EINVAL));
+
+	rv = dotoprocs(&procset, psecdo, (caddr_t)&psd);
+
+	return (rv ? set_errno(rv) : 0);
+}
--- old/usr/src/uts/i86pc/os/mlsetup.c	2016-06-02 19:52:12.536375061 -0400
+++ new/usr/src/uts/i86pc/os/mlsetup.c	2016-06-02 19:52:12.572926052 -0400
@@ -321,6 +321,8 @@
 	p0.p_brkpageszc = 0;
 	p0.p_t1_lgrpid = LGRP_NONE;
 	p0.p_tr_lgrpid = LGRP_NONE;
+	psecflags_default(&p0.p_secflags);
+
 	sigorset(&p0.p_ignore, &ignoredefault);
 
 	CPU->cpu_thread = &t0;
--- old/usr/src/uts/i86pc/vm/vm_machdep.c	2016-06-02 19:52:13.435143120 -0400
+++ new/usr/src/uts/i86pc/vm/vm_machdep.c	2016-06-02 19:52:13.463820083 -0400
@@ -59,6 +59,7 @@
 #include <sys/vmsystm.h>
 #include <sys/swap.h>
 #include <sys/dumphdr.h>
+#include <sys/random.h>
 
 #include <vm/hat.h>
 #include <vm/as.h>
@@ -80,6 +81,7 @@
 #include <sys/cmn_err.h>
 #include <sys/archsystm.h>
 #include <sys/machsystm.h>
+#include <sys/secflags.h>
 
 #include <sys/vtrace.h>
 #include <sys/ddidmareq.h>
@@ -637,6 +639,13 @@
 }
 
 /*
+ * The maximum amount a randomized mapping will be slewed.  We should perhaps
+ * arrange things so these tunables can be separate for mmap, mmapobj, and
+ * ld.so
+ */
+size_t aslr_max_map_skew = 256 * 1024 * 1024; /* 256MB */
+
+/*
  * map_addr_proc() is the routine called when the system is to
  * choose an address for the user.  We will pick an address
  * range which is the highest available below userlimit.
@@ -752,6 +761,7 @@
 	ASSERT(align_amount == 0 || align_amount >= PAGESIZE);
 
 	off = off & (align_amount - 1);
+
 	/*
 	 * Look for a large enough hole starting below userlimit.
 	 * After finding it, use the upper part.
@@ -779,6 +789,20 @@
 			addr -= align_amount;
 		}
 
+		/*
+		 * If randomization is requested, slew the allocation
+		 * backwards, within the same gap, by a random amount.
+		 */
+		if (flags & _MAP_RANDOMIZE) {
+			uint32_t slew;
+
+			(void) random_get_pseudo_bytes((uint8_t *)&slew,
+			    sizeof (slew));
+
+			slew = slew % MIN(aslr_max_map_skew, (addr - base));
+			addr -= P2ALIGN(slew, align_amount);
+		}
+
 		ASSERT(addr > base);
 		ASSERT(addr + len < base + slen);
 		ASSERT(((uintptr_t)addr & (align_amount - 1)) ==
@@ -904,6 +928,13 @@
 }
 
 /*
+ * Default to forbidding the first 64k of address space.  This protects most
+ * reasonably sized structures from dereferences through NULL:
+ *     ((foo_t *)0)->bar
+ */
+uintptr_t forbidden_null_mapping_sz = 0x10000;
+
+/*
  * Determine whether [addr, addr+len] are valid user addresses.
  */
 /*ARGSUSED*/
@@ -916,6 +947,10 @@
 	if (eaddr <= addr || addr >= userlimit || eaddr > userlimit)
 		return (RANGE_BADADDR);
 
+	if ((addr <= (caddr_t)forbidden_null_mapping_sz) &&
+	    secflag_enabled(as->a_proc, PROC_SEC_FORBIDNULLMAP))
+		return (RANGE_BADADDR);
+
 #if defined(__amd64)
 	/*
 	 * Check for the VA hole
@@ -3926,12 +3961,6 @@
 dcache_flushall()
 {}
 
-size_t
-exec_get_spslew(void)
-{
-	return (0);
-}
-
 /*
  * Allocate a memory page.  The argument 'seed' can be any pseudo-random
  * number to vary where the pages come from.  This is quite a hacked up
--- old/usr/src/uts/intel/ia32/ml/modstubs.s	2016-06-02 19:52:14.866732220 -0400
+++ new/usr/src/uts/intel/ia32/ml/modstubs.s	2016-06-02 19:52:14.894472190 -0400
@@ -681,6 +681,7 @@
 	NO_UNLOAD_STUB(procfs, prgetcred,	nomod_zero);
 	NO_UNLOAD_STUB(procfs, prgetpriv,	nomod_zero);
 	NO_UNLOAD_STUB(procfs, prgetprivsize,	nomod_zero);
+       	NO_UNLOAD_STUB(procfs, prgetsecflags,	nomod_zero);
 	NO_UNLOAD_STUB(procfs, prgetstatus,	nomod_zero);
 	NO_UNLOAD_STUB(procfs, prgetlwpstatus,	nomod_zero);
 	NO_UNLOAD_STUB(procfs, prgetpsinfo,	nomod_zero);
@@ -982,6 +983,7 @@
 	NO_UNLOAD_STUB(c2audit, audit_fdrecv,		nomod_zero);
 	NO_UNLOAD_STUB(c2audit, audit_priv,		nomod_zero);
 	NO_UNLOAD_STUB(c2audit, audit_setppriv,		nomod_zero);
+	NO_UNLOAD_STUB(c2audit, audit_psecflags,	nomod_zero);
 	NO_UNLOAD_STUB(c2audit, audit_devpolicy,	nomod_zero);
 	NO_UNLOAD_STUB(c2audit, audit_setfsat_path,	nomod_zero);
 	NO_UNLOAD_STUB(c2audit, audit_cryptoadm,	nomod_zero);
--- old/usr/src/uts/intel/os/name_to_sysnum	2016-06-02 19:52:15.856158988 -0400
+++ new/usr/src/uts/intel/os/name_to_sysnum	2016-06-02 19:52:15.883528182 -0400
@@ -1,5 +1,6 @@
 nosys			0
 rexit			1
+psecflags		2
 read			3
 write			4
 open			5
--- old/usr/src/uts/req.flg	2016-06-02 19:52:16.678734172 -0400
+++ new/usr/src/uts/req.flg	2016-06-02 19:52:16.707613943 -0400
@@ -23,7 +23,6 @@
 # Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-#ident	"%Z%%M%	%I%	%E% SMI"
 
 #
 # Please KEEP THIS (reasonably) ALPHABETIZED BY FILENAME
@@ -53,6 +52,7 @@
 find_files "s.*" usr/src/common/net/wanboot/crypt
 find_files "s.*" usr/src/common/nvpair
 find_files "s.*" usr/src/common/pci
+find_files "s.*" usr/src/common/secflags
 find_files "s.*" usr/src/common/smbios
 find_files "s.*" usr/src/common/tsol
 find_files "s.*" usr/src/common/util
--- old/usr/src/uts/sparc/ml/modstubs.s	2016-06-02 19:52:17.473202352 -0400
+++ new/usr/src/uts/sparc/ml/modstubs.s	2016-06-02 19:52:17.500882300 -0400
@@ -568,6 +568,7 @@
 	NO_UNLOAD_STUB(procfs, prgetcred,	nomod_zero);
 	NO_UNLOAD_STUB(procfs, prgetpriv,	nomod_zero);
 	NO_UNLOAD_STUB(procfs, prgetprivsize,	nomod_zero);
+	NO_UNLOAD_STUB(procfs, prgetsecflags,	nomod_zero);        
 	NO_UNLOAD_STUB(procfs, prgetstatus,	nomod_zero);
 	NO_UNLOAD_STUB(procfs, prgetlwpstatus,	nomod_zero);
 	NO_UNLOAD_STUB(procfs, prgetpsinfo,	nomod_zero);
@@ -901,6 +902,7 @@
 	NO_UNLOAD_STUB(c2audit, audit_fdrecv,		nomod_zero);
 	NO_UNLOAD_STUB(c2audit, audit_priv,		nomod_zero);
 	NO_UNLOAD_STUB(c2audit, audit_setppriv,		nomod_zero);
+	NO_UNLOAD_STUB(c2audit, audit_psecflags,	nomod_zero);
 	NO_UNLOAD_STUB(c2audit, audit_devpolicy,	nomod_zero);
 	NO_UNLOAD_STUB(c2audit, audit_setfsat_path,	nomod_zero);
 	NO_UNLOAD_STUB(c2audit, audit_cryptoadm,	nomod_zero);
--- old/usr/src/uts/sparc/os/name_to_sysnum	2016-06-02 19:52:18.483234498 -0400
+++ new/usr/src/uts/sparc/os/name_to_sysnum	2016-06-02 19:52:18.510767784 -0400
@@ -1,5 +1,6 @@
 nosys			0
 rexit			1
+psecflags		2
 read			3
 write			4
 open			5
--- old/usr/src/uts/sun4/os/mlsetup.c	2016-06-02 19:52:19.328834754 -0400
+++ new/usr/src/uts/sun4/os/mlsetup.c	2016-06-02 19:52:19.359219544 -0400
@@ -189,8 +189,10 @@
 	p0.p_brkpageszc = 0;
 	p0.p_t1_lgrpid = LGRP_NONE;
 	p0.p_tr_lgrpid = LGRP_NONE;
+	psecflags_default(&p0.p_secflags);
 	sigorset(&p0.p_ignore, &ignoredefault);
 
+
 	CPU->cpu_thread = &t0;
 	CPU->cpu_dispthread = &t0;
 	bzero(&cpu0_disp, sizeof (disp_t));
--- old/usr/src/uts/sun4/vm/vm_dep.c	2016-06-02 19:52:20.198858296 -0400
+++ new/usr/src/uts/sun4/vm/vm_dep.c	2016-06-02 19:52:20.226414043 -0400
@@ -37,6 +37,7 @@
 #include <sys/machsystm.h>
 #include <sys/kdi.h>
 #include <sys/cpu_module.h>
+#include <sys/secflags.h>
 
 #include <vm/hat_sfmmu.h>
 
@@ -364,6 +365,13 @@
 }
 
 /*
+ * Default to forbidding the first 64k of address space.  This protects most
+ * reasonably sized structures from dereferences through NULL:
+ *     ((foo_t *)0)->bar
+ */
+uintptr_t forbidden_null_mapping_sz = 0x10000;
+
+/*
  * Determine whether [addr, addr+len] with protections `prot' are valid
  * for a user address space.
  */
@@ -377,6 +385,10 @@
 	if (eaddr <= addr || addr >= userlimit || eaddr > userlimit)
 		return (RANGE_BADADDR);
 
+	if ((addr <= (caddr_t)forbidden_null_mapping_sz) &&
+	    secflag_enabled(as->a_proc, PROC_SEC_FORBIDNULLMAP))
+		return (RANGE_BADADDR);
+
 	/*
 	 * Determine if the address range falls within an illegal
 	 * range of the MMU.
--- old/usr/src/uts/sun4u/vm/mach_vm_dep.c	2016-06-02 19:52:21.147356207 -0400
+++ new/usr/src/uts/sun4u/vm/mach_vm_dep.c	2016-06-02 19:52:21.174787929 -0400
@@ -46,6 +46,7 @@
 #include <sys/memnode.h>
 #include <sys/mem_cage.h>
 #include <vm/vm_dep.h>
+#include <sys/random.h>
 
 #if defined(__sparcv9) && defined(SF_ERRATA_57)
 caddr_t errata57_limit;
@@ -137,6 +138,13 @@
 }
 
 /*
+ * The maximum amount a randomized mapping will be slewed.  We should perhaps
+ * arrange things so these tunables can be separate for mmap, mmapobj, and
+ * ld.so
+ */
+size_t aslr_max_map_skew = 256 * 1024 * 1024; /* 256MB */
+
+/*
  * map_addr_proc() is the routine called when the system is to
  * choose an address for the user.  We will pick an address
  * range which is just below the current stack limit.  The
@@ -265,6 +273,7 @@
 	 */
 	as_purge(as);
 	off = off & (align_amount - 1);
+
 	if (as_gap_aligned(as, len, &base, &slen, AH_HI, NULL, align_amount,
 	    PAGESIZE, off) == 0) {
 		caddr_t as_addr;
@@ -288,6 +297,29 @@
 			addr -= align_amount;
 		}
 
+		/*
+		 * If randomization is requested, slew the allocation
+		 * backwards, within the same gap, by a random amount.
+		 */
+		if (flags & _MAP_RANDOMIZE) {
+			uint32_t slew;
+			uint32_t maxslew;
+
+			(void) random_get_pseudo_bytes((uint8_t *)&slew,
+			    sizeof (slew));
+
+			maxslew = MIN(aslr_max_map_skew, (addr - base));
+			/*
+			 * Don't allow ASLR to cause mappings to fail below
+			 * because of SF erratum #57
+			 */
+			maxslew = MIN(maxslew, (addr - errata57_limit));
+
+			slew = slew % MIN(MIN(aslr_max_map_skew, (addr - base)),
+			    addr - errata57_limit);
+			addr -= P2ALIGN(slew, align_amount);
+		}
+
 		ASSERT(addr > base);
 		ASSERT(addr + len < base + slen);
 		ASSERT(((uintptr_t)addr & (align_amount - 1l)) ==
@@ -349,9 +381,3 @@
 	/* not applicable to sun4u */
 	return (alloc_base);
 }
-
-size_t
-exec_get_spslew(void)
-{
-	return (0);
-}
--- old/usr/src/uts/sun4v/vm/mach_vm_dep.c	2016-06-02 19:52:21.996975789 -0400
+++ new/usr/src/uts/sun4v/vm/mach_vm_dep.c	2016-06-02 19:52:22.024827326 -0400
@@ -52,6 +52,7 @@
 #include <sys/stack.h>
 #include <sys/atomic.h>
 #include <sys/promif.h>
+#include <sys/random.h>
 
 uint_t page_colors = 0;
 uint_t page_colors_mask = 0;
@@ -168,6 +169,13 @@
 static void *contig_mem_prealloc_buf;
 
 /*
+ * The maximum amount a randomized mapping will be slewed.  We should perhaps
+ * arrange things so these tunables can be separate for mmap, mmapobj, and
+ * ld.so
+ */
+size_t aslr_max_map_skew = 256 * 1024 * 1024; /* 256MB */
+
+/*
  * map_addr_proc() is the routine called when the system is to
  * choose an address for the user.  We will pick an address
  * range which is just below the current stack limit.  The
@@ -320,6 +328,20 @@
 			addr -= align_amount;
 		}
 
+		/*
+		 * If randomization is requested, slew the allocation
+		 * backwards, within the same gap, by a random amount.
+		 */
+		if (flags & _MAP_RANDOMIZE) {
+			uint32_t slew;
+
+			(void) random_get_pseudo_bytes((uint8_t *)&slew,
+			    sizeof (slew));
+
+			slew = slew % MIN(aslr_max_map_skew, (addr - base));
+			addr -= P2ALIGN(slew, align_amount);
+		}
+
 		ASSERT(addr > base);
 		ASSERT(addr + len < base + slen);
 		ASSERT(((uintptr_t)addr & (align_amount - 1l)) ==
@@ -775,14 +797,3 @@
 
 	return (alloc_base);
 }
-
-static uint_t sp_color_stride = 16;
-static uint_t sp_color_mask = 0x1f;
-static uint_t sp_current_color = (uint_t)-1;
-
-size_t
-exec_get_spslew(void)
-{
-	uint_t spcolor = atomic_inc_32_nv(&sp_current_color);
-	return ((size_t)((spcolor & sp_color_mask) * SA(sp_color_stride)));
-}
